import DCinsideRead.dcinside as dc
import DCinsideRead.common as common
import pandas as pd
import random
import time
from selenium import webdriver
from selenium.webdriver.common.by import By
from selenium.webdriver.support.ui import WebDriverWait
from selenium.webdriver.support import expected_conditions as EC
from selenium.common.exceptions import TimeoutException
from selenium.webdriver.common.keys import Keys
import datetime
import time
import re
import string
from bs4 import BeautifulSoup
import gspread
random.seed(time.time())
KST = datetime.timezone(datetime.timedelta(hours=9))


def try_until_success_ignoring_pop_up_and_(func):
    func_name = func.__name__

    def wrapper(*args, **kwargs):
        # time.sleep(1)
        start_time = time.time()
        while True:
            if time.time() - start_time > 4:
                print("원인은 알 수 없으나 4초 이상 실패하여 함수를 빠져나옵니다")
                return
                # break
            try:
                result = func(*args, **kwargs)
            except:
                continue
            else:
                return result
        # return result
    return wrapper


def convert_worksheet_to_dictionary(worksheet=False, *args):
    if worksheet is False:
        print("worksheet 가 입력되지 않아 함수를 비정상적으로 종료합니다")
        assert 1 == 2
        return None
    else:
        rows = worksheet.get_all_values()
        df = pd.DataFrame.from_records(rows[1:], columns=rows[0])
        df = df.astype(str)
        df_to_dict = dict(zip(list(df.col1), df.col2))
        if "nan" in df_to_dict.keys():
            del df_to_dict["nan"]
        if "" in df_to_dict.keys():
            del df_to_dict[""]
        return df_to_dict


@try_until_success_ignoring_pop_up_and_
def driver_get_url(driver=0, url=0, *args):
    driver.get(url)


@try_until_success_ignoring_pop_up_and_
def click_login_start_button(driver=0, *args):
    driver.find_element_by_xpath("//*[@id=\"top\"]/header/div/div[2]/ul/li[6]/a").click()


@try_until_success_ignoring_pop_up_and_
def id_input(driver=0, id=0, *args):
    # time.sleep(0.5)
    driver.find_element_by_xpath("//*[@id=\"id\"]").send_keys(id)


@try_until_success_ignoring_pop_up_and_
def password_input(driver=0, password=0, *args):
    # time.sleep(0.5)
    driver.find_element_by_xpath("//*[@id=\"pw\"]").send_keys(password)


@try_until_success_ignoring_pop_up_and_
def click_login_complete_button(driver=0, *args):
    driver.find_element_by_xpath(
        "//*[@id=\"container\"]/div/article/section/div/div[1]/div/form/fieldset/button").click()


@try_until_success_ignoring_pop_up_and_
def click_report_start_button(driver=0, *args):
    driver.find_element_by_xpath("//*[@id=\"container\"]/section/article[2]/div[1]/div/div[3]/div[3]/button[3]").click()


@try_until_success_ignoring_pop_up_and_
def click_report_select_between_2_button(driver=0, *args):
    driver.find_element_by_xpath("//*[@id=\"singo_lyr\"]/div/div[2]/button[2]").click()


@try_until_success_ignoring_pop_up_and_
def click_report_select_pornography(driver=0, *args):
    driver.find_element_by_xpath("//*[@id=\"singo_lyr\"]/div/div[2]/button[1]").click()


@try_until_success_ignoring_pop_up_and_
def click_ok_on_pop_up_button(driver=0, *args):
    driver.switch_to.alert.accept()


@try_until_success_ignoring_pop_up_and_
def click_report_select_reason_button(driver=0, *args):
    driver.find_element_by_xpath("//*[@id=\"container\"]/div/article/section[2]/div/div[2]/div[1]/ul/li[7]/a").click()


@try_until_success_ignoring_pop_up_and_
def driver_switch_to_new_window_or_tab(driver=0, *args):
    driver.switch_to.window(driver.window_handles[1])


@try_until_success_ignoring_pop_up_and_
def reason_input(driver=0, reason=0, *args):
    # time.sleep(0.5)
    driver.find_element_by_xpath("//*[@id=\"singo_reason\"]").send_keys(reason)


@try_until_success_ignoring_pop_up_and_
def click_report_submit_button(driver=0, *args):
    driver.find_element_by_xpath("//*[@id=\"singo_submit\"]").click()


@try_until_success_ignoring_pop_up_and_
def close_current_tab(driver=0, *args):
    driver.close()


@try_until_success_ignoring_pop_up_and_
def driver_switch_to_post_window_or_tab_after_closing(driver=0, *args):
    driver.switch_to.window(driver.window_handles[0])


@try_until_success_ignoring_pop_up_and_
def click_by_xpath(driver=0, xpath=0, *args):
    driver.find_element_by_xpath(xpath).click()


@try_until_success_ignoring_pop_up_and_
def execute_report(driver, url, reason, *args):
    driver_get_url(driver, url)
    click_report_start_button(driver)
    click_report_select_between_2_button(driver)
    click_ok_on_pop_up_button(driver)
    driver_switch_to_new_window_or_tab(driver)
    click_report_select_reason_button(driver)
    click_ok_on_pop_up_button(driver)
    time.sleep(1)
    try:
        alert = driver.switch_to.alert
        if "이미" in alert.text:
            print("이미 신고가 접수된 게시물입니다")
            click_ok_on_pop_up_button(driver)
            close_current_tab(driver)
            driver_switch_to_post_window_or_tab_after_closing(driver)
            return "already"
    except:
        pass
    reason_input(driver, reason)
    click_report_submit_button(driver)
    time.sleep(1)
    try:
        alert = driver.switch_to.alert
        if "지연" in alert.text:
            print("id가 신고를 못하도록 차단된 상태입니다")
            click_ok_on_pop_up_button(driver)
            close_current_tab(driver)
            driver_switch_to_post_window_or_tab_after_closing(driver)
            return False
    except:
        pass
    # time.sleep(1)
    # whether_report_success = False
    # driver_get_url("https://gall.dcinside.com/board/lists?id=singo")
    # click_by_xpath(driver, "//*[@id=\"container\"]/section[1]/article[2]/div[1]/table/tbody/tr[1]/td[2]/a")

    print("신고가 성공하였습니다")
    close_current_tab(driver)
    driver_switch_to_post_window_or_tab_after_closing(driver)
    return True


# @try_until_success_ignoring_pop_up_and_
def execute_report_pornography(driver, url, *args):
    # print("a")
    driver.get(url)
    # driver_get_url(driver, url)
    # print("b")
    report_start_button_xpath = '//*[@id="container"]/section/article[2]/div[1]/div/div[3]/div[3]/button[3]'
    # return
    WebDriverWait(driver, 3).until(
        EC.presence_of_element_located((By.XPATH, report_start_button_xpath))
    )
    driver.find_element_by_xpath(report_start_button_xpath).click()

    try:
        WebDriverWait(driver, 1).until(
            EC.alert_is_present()
        )
        alert = driver.switch_to.alert
        alert.accept()
    except TimeoutException:
        pass

    report_pornography_button_xpath = '//*[@id="singo_lyr"]/div/div[2]/button[1]'
    WebDriverWait(driver, 3).until(
        EC.presence_of_element_located((By.XPATH, report_pornography_button_xpath))
    )
    driver.find_element_by_xpath(report_pornography_button_xpath).click()
    try:
        WebDriverWait(driver, 1).until(
            EC.alert_is_present()
        )
        alert = driver.switch_to.alert
        alert.accept()
    except TimeoutException:
        pass

    try:
        WebDriverWait(driver, 1).until(
            EC.alert_is_present()
        )
        alert = driver.switch_to.alert
        if "이미" in alert.text:
            print("이미 신고가 접수된 게시물입니다")
            alert.accept()
            return "already"
    except TimeoutException:
        pass

    try:
        WebDriverWait(driver, 1).until(
            EC.alert_is_present()
        )
        alert = driver.switch_to.alert
        alert.accept()
    except TimeoutException:
        pass

    print("신고가 성공하였습니다")
    return True


@try_until_success_ignoring_pop_up_and_
def execute_login(driver, url, user_name, password, *args):
    driver_get_url(driver, url)
    click_login_start_button(driver)
    id_input(driver, user_name)
    password_input(driver, password)
    click_login_complete_button(driver)
    time.sleep(1)
    try:
        alert = driver.switch_to.alert
        if "잘못" in alert.text:
            return False
    except:
        return True


@try_until_success_ignoring_pop_up_and_
def execute_logout(driver, url, *args):
    driver_get_url(driver, url)
    click_login_start_button(driver)


@try_until_success_ignoring_pop_up_and_
def execute_driver(disable_gpu=True, headless=False, executable_path=False, google_colab=False, **kwargs):
    # PROXY = "23.23.23.23:3128"  # IP:PORT or HOST:PORT
    if executable_path is False:
        now = datetime.datetime.now(KST)
        print("현재 시각은 %s년 %s월 %s일 %s시 %s분 %s초" % (now.year, now.month, now.day, now.hour, now.minute, now.second))
        print("chromedriver의 path가 입력되지 않아 함수를 비정상적으로 종료합니다")
        return
    chrome_options = webdriver.ChromeOptions()
    # options = webdriver.FirefoxOptions()
    if google_colab:
        chrome_options.add_argument('--headless')
        chrome_options.add_argument('--no-sandbox')
        chrome_options.add_argument('--disable-dev-shm-usage')
    else:
        if disable_gpu:
            chrome_options.add_argument("disable-gpu")
        if headless:
            chrome_options.add_argument("--headless")

    # proxy_ip = "123.143.203.194"
    # proxy_port = "4145"
    # proxy_string = "--proxy-server=" + proxy_ip + ":" + proxy_port
    # chrome_options.add_argument(proxy_string)

    driver = webdriver.Chrome(options=chrome_options, executable_path=executable_path)
    # driver = webdriver.Firefox(options=options)
    # driver = webdriver.Firefox()
    return driver


def pornography(gallery_name="클래식", *args,
                user_name=False, password=False,
                user_name_password_dictionary=False,
                keyword_ban_dictionary=False,
                writer_ban_dictionary=False,
                ip_ban_dictionary=False,
                start_page=False, last_page=False, how_many_pages=1,
                disable_gpu=True, headless=False, executable_path=False,
                google_colab=False,
                **kwargs):
    start_time = time.time()
    now = datetime.datetime.now(KST)
    print("현재 시각은 %s년 %s월 %s일 %s시 %s분 %s초" % (now.year, now.month, now.day, now.hour, now.minute, now.second))
    print("함수 pornography 를 시작합니다.")

    if executable_path is False:
        now = datetime.datetime.now(KST)
        print("현재 시각은 %s년 %s월 %s일 %s시 %s분 %s초" % (now.year, now.month, now.day, now.hour, now.minute, now.second))
        print("chromedriver 의 path 가 입력되지 않아 함수를 비정상적으로 종료합니다")
        return

    page_and_base_url_dictionary = dc.get_page_and_base_url_dictionary(gallery_name)
    if type(start_page) is int and start_page > 0:
        page_and_base_url_dictionary["start_page"] = start_page
    if type(last_page) is int and last_page > 0:
        page_and_base_url_dictionary["last_page"] = last_page
    elif type(how_many_pages) is int and how_many_pages > 0:
        page_and_base_url_dictionary["last_page"] = page_and_base_url_dictionary["start_page"] + (how_many_pages - 1)


    print("start_page =", page_and_base_url_dictionary["start_page"])
    print("last_page =", page_and_base_url_dictionary["last_page"])

    post_list_csv_path_file_name = dc.read_lists_of_posts_and_save_it_to_csv(page_and_base_url_dictionary,
                                                                             multiprocessing=True,
                                                                             pre_delete_all_legacy_merged_data=True,
                                                                             pre_delete_all_legacy_raw_data=True)
    post_list_csv = pd.read_csv(post_list_csv_path_file_name)

    now = datetime.datetime.now(KST)
    print("현재 시각은 %s년 %s월 %s일 %s시 %s분 %s초" % (now.year, now.month, now.day, now.hour, now.minute, now.second))
    print("\n\n*** 신고 후보를 선별하는 Loop 에 진입합니다 ***\n\n")
    report_dictionary = {}
    for index in range(len(post_list_csv)):
        use_next_function = True
        for key in keyword_ban_dictionary.keys():
            if key in str(post_list_csv.loc[index]["title"]):
                # print("key =", key, "title =", str(post_list_csv.loc[index]["title"]))
                # return
                report_dictionary[post_list_csv.loc[index]["post_url"]] = {
                    "title": post_list_csv.loc[index]["title"],
                    "writer": post_list_csv.loc[index]["writer"],
                    "ip": post_list_csv.loc[index]["ip"],
                    "date": post_list_csv.loc[index]["date"],
                    "post_number": post_list_csv.loc[index]["post_number"],
                    "report_reason": keyword_ban_dictionary[key] + str(random.randint(0, 100000000))
                }
                use_next_function = False
                break

        if use_next_function:
            for key in writer_ban_dictionary.keys():
                if key in str(post_list_csv.loc[index]["writer"]):
                    # print("writer =", key, "writer =", str(post_list_csv.loc[index]["writer"]))
                    # return
                    report_dictionary[post_list_csv.loc[index]["post_url"]] = {
                        "title": post_list_csv.loc[index]["title"],
                        "writer": post_list_csv.loc[index]["writer"],
                        "ip": post_list_csv.loc[index]["ip"],
                        "date": post_list_csv.loc[index]["date"],
                        "post_number": post_list_csv.loc[index]["post_number"],
                        "report_reason": writer_ban_dictionary[key] + str(random.randint(0, 100000000))
                    }
                    use_next_function = False
                    break

        if use_next_function:
            for key in ip_ban_dictionary.keys():
                if key in str(post_list_csv.loc[index]["ip"]):
                    # print("ip =", key, "ip =", str(post_list_csv.loc[index]["ip"]))
                    # return
                    report_dictionary[post_list_csv.loc[index]["post_url"]] = {
                        "title": post_list_csv.loc[index]["title"],
                        "writer": post_list_csv.loc[index]["writer"],
                        "ip": post_list_csv.loc[index]["ip"],
                        "date": post_list_csv.loc[index]["date"],
                        "post_number": post_list_csv.loc[index]["post_number"],
                        "report_reason": ip_ban_dictionary[key] + str(random.randint(0, 100000000))
                    }
                    use_next_function = False
                    break
    if len(list(report_dictionary.keys())) is 0:
        print("신고 후보 게시물이 0개여서 프로그램을 종료합니다")
        return
    else:
        print("\n\n *** 신고 후보 게시물은", len(list(report_dictionary.keys())), "개 입니다 *** \n\n")

    now = datetime.datetime.now(KST)
    print("현재 시각은 %s년 %s월 %s일 %s시 %s분 %s초" % (now.year, now.month, now.day, now.hour, now.minute, now.second))
    print("webdriver 를 켭니다")
    driver = execute_driver(disable_gpu=disable_gpu, headless=headless, executable_path=executable_path,
                            google_colab=google_colab)
    # print("로그인을 시도할 id =", str(user_name))

    report_success_count = 0
    report_already_count = 0
    try_login_count = 0
    for key in report_dictionary.keys():
        url = key + "&t=cv"
        reason = report_dictionary[key]["report_reason"]
        now = datetime.datetime.now(KST)
        print("현재 시각은 %s년 %s월 %s일 %s시 %s분 %s초" % (now.year, now.month, now.day, now.hour, now.minute, now.second))
        print("\ntitle:", report_dictionary[key]["title"], "\nwriter:", report_dictionary[key]["writer"], "  ip:",
              report_dictionary[key]["ip"])
        # print("url:", url, "인 게시물을\n", reason, "\n을(를) 이유로 신고 시도합니다")
        print("url:", url, "인 게시물을", "\n음란물로 신고 시도합니다")
        report_success_or_not = execute_report_pornography(driver, url)
        if report_success_or_not:
            report_success_count += 1
        elif report_success_or_not is "already":
            report_already_count += 1

    if report_success_count == len(list(report_dictionary.keys())):
        print("\n후보", len(list(report_dictionary.keys())), "개를 모두 신고하는 데 성공하였습니다")
        print("(이미 신고된", report_already_count, "건 포함)")
    else:
        print("\n", len(list(report_dictionary.keys())), "개의 신고 대상 중", report_success_count, "개만 신고에 성공하였습니다")
        print("(이미 신고된", report_already_count, "건 포함)")

    execute_logout(driver, url)
    print("종료 전에 로그아웃하였습니다")
    driver.close()
    now = datetime.datetime.now(KST)
    print("현재 시각은 %s년 %s월 %s일 %s시 %s분 %s초" % (now.year, now.month, now.day, now.hour, now.minute, now.second))
    print("general 를 종료합니다")
    print("함수 general 를 끝마치는 데 %.2f초 걸렸습니다" % (time.time() - start_time))
    return


def general(gallery_name="클래식", *args,
            user_name=False, password=False,
            user_name_password_dictionary=False,
            keyword_ban_dictionary=False,
            writer_ban_dictionary=False,
            ip_ban_dictionary=False,
            start_page=False, last_page=False, how_many_pages=1,
            disable_gpu=True, headless=False, executable_path=False,
            google_colab=False,
            **kwargs):

    start_time = time.time()
    now = datetime.datetime.now(KST)
    print("현재 시각은 %s년 %s월 %s일 %s시 %s분 %s초" % (now.year, now.month, now.day, now.hour, now.minute, now.second))
    print("함수 general 를 시작합니다.")

    if executable_path is False:
        now = datetime.datetime.now(KST)
        print("현재 시각은 %s년 %s월 %s일 %s시 %s분 %s초" % (now.year, now.month, now.day, now.hour, now.minute, now.second))
        print("chromedriver 의 path 가 입력되지 않아 함수를 비정상적으로 종료합니다")
        return

    if user_name_password_dictionary is False:
        if user_name is False:
            now = datetime.datetime.now(KST)
            print("현재 시각은 %s년 %s월 %s일 %s시 %s분 %s초" % (now.year, now.month, now.day, now.hour, now.minute, now.second))
            print("id가 입력되지 않았습니다. general 를 종료합니다")
            return
        if password is False:
            now = datetime.datetime.now(KST)
            print("현재 시각은 %s년 %s월 %s일 %s시 %s분 %s초" % (now.year, now.month, now.day, now.hour, now.minute, now.second))
            print("password 가 입력되지 않았습니다. general 를 종료합니다")
            return
    else:
        random.seed(time.time())
        user_name_list = list(user_name_password_dictionary.keys())
        user_name_password_list_index = datetime.datetime.now(KST).second % len(user_name_list)
        user_name = user_name_list[user_name_password_list_index]
        password = user_name_password_dictionary[user_name]

    page_and_base_url_dictionary = dc.get_page_and_base_url_dictionary(gallery_name)
    if type(start_page) is int and start_page > 0:
        page_and_base_url_dictionary["start_page"] = start_page
    if type(last_page) is int and last_page > 0:
        page_and_base_url_dictionary["last_page"] = last_page
    elif type(how_many_pages) is int and how_many_pages > 0:
        page_and_base_url_dictionary["last_page"] = page_and_base_url_dictionary["start_page"] + (how_many_pages - 1)

    print("start_page =", page_and_base_url_dictionary["start_page"])
    print("last_page =", page_and_base_url_dictionary["last_page"])

    post_list_csv_path_file_name = dc.read_lists_of_posts_and_save_it_to_csv(page_and_base_url_dictionary,
                                                                             multiprocessing=True,
                                                                             pre_delete_all_legacy_merged_data=True,
                                                                             pre_delete_all_legacy_raw_data=True)
    post_list_csv = pd.read_csv(post_list_csv_path_file_name)

    now = datetime.datetime.now(KST)
    print("현재 시각은 %s년 %s월 %s일 %s시 %s분 %s초" % (now.year, now.month, now.day, now.hour, now.minute, now.second))
    print("신고 후보를 선별하는 Loop 에 진입합니다")
    report_dictionary = {}
    for index in range(len(post_list_csv)):
        use_next_function = True
        for key in keyword_ban_dictionary.keys():
            if key in str(post_list_csv.loc[index]["title"]):
                # print("key =", key, "title =", str(post_list_csv.loc[index]["title"]))
                # return
                report_dictionary[post_list_csv.loc[index]["post_url"]] = {
                    "title": post_list_csv.loc[index]["title"],
                    "writer": post_list_csv.loc[index]["writer"],
                    "ip": post_list_csv.loc[index]["ip"],
                    "date": post_list_csv.loc[index]["date"],
                    "post_number": post_list_csv.loc[index]["post_number"],
                    "report_reason": keyword_ban_dictionary[key] + str(random.randint(0, 100000000))
                }
                use_next_function = False
                break

        if use_next_function:
            for key in writer_ban_dictionary.keys():
                if key in str(post_list_csv.loc[index]["writer"]):
                    # print("writer =", key, "writer =", str(post_list_csv.loc[index]["writer"]))
                    # return
                    report_dictionary[post_list_csv.loc[index]["post_url"]] = {
                        "title": post_list_csv.loc[index]["title"],
                        "writer": post_list_csv.loc[index]["writer"],
                        "ip": post_list_csv.loc[index]["ip"],
                        "date": post_list_csv.loc[index]["date"],
                        "post_number": post_list_csv.loc[index]["post_number"],
                        "report_reason": writer_ban_dictionary[key] + str(random.randint(0, 100000000))
                    }
                    use_next_function = False
                    break

        if use_next_function:
            for key in ip_ban_dictionary.keys():
                if key in str(post_list_csv.loc[index]["ip"]):
                    # print("ip =", key, "ip =", str(post_list_csv.loc[index]["ip"]))
                    # return
                    report_dictionary[post_list_csv.loc[index]["post_url"]] = {
                        "title": post_list_csv.loc[index]["title"],
                        "writer": post_list_csv.loc[index]["writer"],
                        "ip": post_list_csv.loc[index]["ip"],
                        "date": post_list_csv.loc[index]["date"],
                        "post_number": post_list_csv.loc[index]["post_number"],
                        "report_reason": ip_ban_dictionary[key] + str(random.randint(0, 100000000))
                    }
                    use_next_function = False
                    break
    if len(list(report_dictionary.keys())) is 0:
        print("신고 후보 게시물이 0개여서 프로그램을 종료합니다")
        return
    else:
        print("\n\n*** 신고 후보 게시물은", len(list(report_dictionary.keys())), "개 입니다 ***\n\n")

    now = datetime.datetime.now(KST)
    print("현재 시각은 %s년 %s월 %s일 %s시 %s분 %s초" % (now.year, now.month, now.day, now.hour, now.minute, now.second))
    print("webdriver 를 켜고 로그인을 시도합니다")
    driver = execute_driver(disable_gpu=disable_gpu, headless=headless, executable_path=executable_path,
                            google_colab=google_colab)
    print("로그인을 시도할 id =", str(user_name))
    try_login_count = 0
    while True:
        try_login_count += 1
        if execute_login(driver, page_and_base_url_dictionary["url"],
                         user_name, password) is True:
            print("로그인에 성공하였습니다")
            print("신고 게시물을 작성할 id =", str(user_name))
            break
        elif user_name_password_dictionary is not False:
            user_name_list = list(user_name_password_dictionary.keys())
            user_name_password_list_index = (user_name_password_list_index + 1) % len(user_name_list)
            user_name = user_name_list[user_name_password_list_index]
            password = user_name_password_dictionary[user_name]
            print("로그인 문제가 발생하여 신고 게시물을 작성할 id 를 ", str(user_name), " 로 변경하였습니다")
        if try_login_count > 10:
            print("모든 로그인 정보가 잘못되거나, 거듭된 로그인으로 인해 자동 문자 입력이 발생하는 일이 10번 이상 일어나 프로그램을 종료합니다")
            return
    print("신고 시도 Loop 에 진입합니다")
    report_success_count = 0
    report_already_count = 0
    try_login_count = 0
    for key in report_dictionary.keys():
        url = key + "&t=cv"
        reason = report_dictionary[key]["report_reason"]
        now = datetime.datetime.now(KST)
        print("현재 시각은 %s년 %s월 %s일 %s시 %s분 %s초" % (now.year, now.month, now.day, now.hour, now.minute, now.second))
        print("\ntitle:", report_dictionary[key]["title"], "\nwriter:", report_dictionary[key]["writer"], "  ip:", report_dictionary[key]["ip"])
        print("url:", url, "인 게시물을\n", reason, "\n을(를) 이유로 신고 시도합니다")
        report_success_or_not = execute_report(driver, url, reason)
        if report_success_or_not is False or ((report_success_count % 5 == 0) and report_success_count > 0):
            while True:
                if report_success_or_not is True:
                    print("신고를 연속으로 5번 접수하였기에 id를 변경합니다")
                print("다른 id로 다시 로그인하여 시도합니다")
                try_login_count += 1
                if user_name_password_dictionary is not False:
                    execute_logout(driver, url)
                    print("기존의 id 를 로그아웃하였습니다")
                    user_name_list = list(user_name_password_dictionary.keys())
                    user_name_password_list_index = (user_name_password_list_index + 1) % len(user_name_list)
                    user_name = user_name_list[user_name_password_list_index]
                    password = user_name_password_dictionary[user_name]
                    print("신고 게시물을 작성할 id 를", str(user_name), "로 변경하였습니다")
                if execute_login(driver, page_and_base_url_dictionary["url"],
                                 user_name, password) is True:
                    print("로그인에 성공하였습니다")
                    print("신고 게시물을 작성할 id =", str(user_name))
                if try_login_count >= len(user_name_list):
                    print("id가 차단되는 일이 전체 id 리스트 길이와 같은", len(user_name_list), "번 이상 일어나 프로그램을 종료합니다")
                    driver.quit()
                    driver.close()
                    return
                report_success_or_not = execute_report(driver, url, reason)
                if report_success_or_not is not False:
                    break
        report_success_count += 1
        if report_success_or_not is "already":
            report_already_count += 1

    if report_success_count == len(list(report_dictionary.keys())):
        print("\n\n*** 후보", len(list(report_dictionary.keys())), "개를 모두 신고하는 데 성공하였습니다 ***\n\n")
        print("(이미 신고된", report_already_count, "건 포함)")
    else:
        print("\n\n ***", len(list(report_dictionary.keys())), "개의 신고 대상 중", report_success_count, "개만 신고에 성공하였습니다 ***\n\n")
        print("(이미 신고된", report_already_count, "건 포함)")

    execute_logout(driver, url)
    print("종료 전에 로그아웃하였습니다")
    driver.quit()
    driver.close()
    now = datetime.datetime.now(KST)
    print("현재 시각은 %s년 %s월 %s일 %s시 %s분 %s초" % (now.year, now.month, now.day, now.hour, now.minute, now.second))
    print("함수 general 를 종료합니다")
    print("함수 general 를 끝마치는 데 %.2f초 걸렸습니다" % (time.time() - start_time))
    return


if __name__ == "__main__":
    pass
